Summary: Fcron is a task scheduler.
Name: fcron
Version: 2.9.6
Release: 14tr
License: GPL
Group: Trustix Official
Source0: http://fcron.free.fr/%{name}-%{version}.src.tar.gz
Source2: fcron.init
Source3: fcrontab-default
#Patch0: fcron-2.9.4-selinux.patch
Patch1 : fcron-2.9.6-stdout.patch
Patch2: fcron-overflow.patch
BuildRoot: %{_tmppath}/%{name}-root
Provides: crond
PreReq: crontabs shadow-utils tsl-utils chkconfig setup
PreReq: grep mktemp filesystem

%description
Fcron is a scheduler. It aims at replacing Vixie Cron, so it implements most
of its functionalities.

But contrary to Vixie Cron, fcron does not need your system to be up 7 days
a week, 24 hours a day : it also works well with systems which are
not running neither all the time nor regularly (contrary to anacrontab).

In other words, fcron does both the job of Vixie Cron and anacron, but does
even more and better :)) ...

%prep
%setup -q
#%patch0 -p1
%patch1 -p1
%patch2 -p1

%build
autoconf
%configure --prefix=%{_prefix} \
	--mandir=%{_mandir} \
	--with-sendmail=/usr/sbin/sendmail \
	%{?use_selinux: --with-selinux=yes} --with-pam=no \
	--with-answer-all=no
make OPTIM="${RPM_OPT_FLAGS} -I/usr/include/selinux"

%install
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

  mkdir -p ${RPM_BUILD_ROOT}%{_prefix}/bin
  mkdir -p ${RPM_BUILD_ROOT}%{_docdir}
  mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
  mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man{1,3,5,8}
  mkdir -p ${RPM_BUILD_ROOT}/etc/init.d/
  #mkdir -p ${RPM_BUILD_ROOT}/var/spool/fcron

  make install \
  ETC=${RPM_BUILD_ROOT}%{_sysconfdir} \
  DESTBIN=${RPM_BUILD_ROOT}%{_prefix}/bin \
  DESTSBIN=${RPM_BUILD_ROOT}%{_sbindir} \
  DESTMAN=${RPM_BUILD_ROOT}%{_mandir} \
  DESTDOC=${RPM_BUILD_ROOT}%{_docdir} \
  FCRONTABS=${RPM_BUILD_ROOT}/var/spool/fcron

  install -c -m 755 %{SOURCE2} ${RPM_BUILD_ROOT}%{_initdir}/fcron
  install -c -m 755 convert-fcrontab ${RPM_BUILD_ROOT}%{_bindir}
  
  # Install check_system_crontabs script.
  install -c -m 755 script/check_system_crontabs ${RPM_BUILD_ROOT}%{_bindir}

pushd $RPM_BUILD_ROOT%{_prefix}/bin
  ln -s fcrontab crontab
popd

pushd $RPM_BUILD_ROOT%{_mandir}/man1
  ln -s fcrontab.1 crontab.1
popd

install -m 644 %{SOURCE3} fcrontab-default

%pre
# create user and group if not yet created:
if ! getent group fcron >/dev/null 2>/dev/null; then
        /usr/sbin/groupadd -g 108 fcron
fi
if ! getent passwd fcron >/dev/null 2>/dev/null; then
        /usr/sbin/useradd -M -d /no/dir \
	-s /bin/false -c "fcron user" -g fcron -u 108 fcron
fi

%post
FSPOOL=/var/spool/fcron
TMPORIG=`mktemp /tmp/fcron.orig.XXXXXX`
if [ "$1" = 1 ]; then
if [ ! -f $FSPOOL/root ]; then
# install default crontab:
/usr/bin/fcrontab %{_docdir}/%{name}-%{version}/fcrontab-default >/dev/null 2>&1
fi
fi

/sbin/chkconfig --add fcron
# Force a startup
/sbin/chkconfig fcron on

if [ $1 = 2 ]; then
if [ ! -f $FSPOOL/root.orig ]; then
# install default crontab:
    /usr/bin/fcrontab %{_docdir}/%{name}-%{version}/fcrontab-default >/dev/null 2>&1
else
# Add the new settings into existing configurations
    pushd $FSPOOL >/dev/null 2>&1
    for i in *.orig; do
    /bin/grep -e "mail(yes)" -e "noticenotrun(yes)" $i >/dev/null 2>&1; RETVAL=$?
    if [ "$RETVAL" != "0" ]; then
    sed -e '1s/^/\!mail\(yes\)\,noticenotrun\(yes\)\n/' $i > $TMPORIG
    mv $TMPORIG $i 
    /usr/bin/fcrontab $i -u `echo $i | awk -F. '{print $1}'` >/dev/null 2>&1 
    fi
    done
    popd >/dev/null 2>&1
fi
   /sbin/restart_maybe fcron
fi

%preun
if [ "$1" = "0" ]; then
  /sbin/chkconfig --del fcron
fi

%clean
[ -n "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != / ] && rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
%doc doc/txt/changes.txt doc/txt/faq.txt doc/txt/gpl.txt doc/txt/install.txt doc/txt/readme.txt doc/txt/relnotes.txt doc/txt/thanks.txt doc/txt/todo.txt fcrontab-default
%attr(644,root,fcron) %config(noreplace) %{_sysconfdir}/fcron.conf
%attr(644,root,fcron) %config(noreplace) %{_sysconfdir}/fcron.allow
%attr(644,root,fcron) %config(noreplace) %{_sysconfdir}/fcron.deny
%{_initdir}/fcron
%{_mandir}/man8/fcron.8*
%{_mandir}/man1/fcrontab.1*
%{_mandir}/man1/fcrondyn.1*
%{_mandir}/man1/crontab.1*
%{_mandir}/man5/fcrontab.5*
%{_mandir}/man5/fcron.conf.5*
%{_mandir}/man3/bitstring.3*
%attr(755,root,root) %{_bindir}/convert-fcrontab
%attr(6111,root,root) %{_bindir}/fcronsighup
%attr(6111,fcron,fcron) %{_bindir}/fcrontab
%attr(6111,fcron,fcron) %{_bindir}/fcrondyn
%{_bindir}/crontab
%{_bindir}/check_system_crontabs
%attr(110,root,root) %{_sbindir}/fcron
%attr(770,fcron,fcron) /var/spool/fcron

%changelog
* Fri Jul 27 2007 Nived Gopalan <nived at trustix dot org> 2.6.9-14tr
- Added PreReq setup.
- Added -M option to useradd, Bug #2240.

* Wed Jun 14 2006 Nived Gopalan <nived at trustix dot org> 2.6.9-13tr
- Patched to fix buffer overflow due to a bug in make_msg(), Bug #1754.

* Thu Feb 09 2006 Nived Gopalan <nived at trustix dot org> 2.6.9-12tr
- SECURITY Fix: Adam Zabrocki and Karol Wiesek has reported vulnerabilities
  in fcron, which can be exploited by malicious, local users to gain
  escalated privileges. The issue exits in convert-fcrontab when handling
  an overly long username supplied via the command line and due to missing
  validation of username. (SA18719)

* Fri Aug 12 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 2.6.9-11tr
- Ship check_system_crontabs script

* Wed Jun 15 2005 Ajith Thampi <ajith at comodo dot com> 2.6.9-10tr
- Updated the fcrontab-default to use default HOME per user. Bug #747
		
* Wed Jun 01 2005 Ajith Thampi <ajith at comodo dot com> 2.6.9-9tr
- Added patch by Thibault Godouet to fix the no stdout on fcron job.
		
* Thu May 26 2005 Oystein Viggen <oysteivi at trustix dot com> 2.6.9-7tr
- Create tempfile in /tmp instead of /
- PreReq filesystem to make sure we have /tmp

* Wed May 11 2005 Ajith Thampi <ajith at comodo dot com> 2.9.6-4tr
- Added a new set of lines in the fcrontab which basically solves the Bug #552
  A big change is noticed by which the new set of settings are added into an
  existing fcrontab .orig in /var/spool/fcron/		

* Thu Apr 21 2005 Syed Shabir Zakiullah <syedshabir at comodo dot com> 2.9.6-3tr
- Fix Bug ID: 411 (changed permission of *.conf files to 644 from 640)

* Wed Apr 20 2005 Thushara Gopalakrishnan <thushara at comodo dot com>  2.9.6-2tr
- Changed init priority

* Tue Mar 15 2005 Raghu <raghu at comodo dot com> 2.9.6-1tr
- New Upstream

* Thu Mar 10 2005 Oystein Viggen <oysteivi at trustix dot com> 2.9.5.1-2tr
- Include fcrondyn and man page
- Search for selinux header files in /usr/include/selinux

* Fri Dec 31 2004 Olaf Rempel <razzor at kopf minus tisch dot de> 2.9.5.1-1tr
- Security Update (CAN-2004-1030)

* Mon Oct 18 2004 Erlend Midttun <erlendbm at trustix dot org> 2.9.5-2tr
- Only restart if upgrade.

* Wed Sep 22 2004 Syed Shabir <syedshabir at comodo dot com> 2.9.5-1tr
- new upstream

* Wed Apr 28 2004 Erlend Midttun <erlendbm at trustix dot org> 2.9.4-8tr
- s/postun/preun/

* Wed Apr 28 2004 Erlend Midttun <erlendbm at trustix dot org> 2.9.4-7tr
- Now use %%{_docdir}/%%{name}-%%{version} in %%post.

* Tue Mar 23 2004 Chr. Toldnes <christht at trustix dot org> 2.9.4-6tr
- Rearranged automatic handling of roots crontab

* Tue Mar  2 2004 Oystein Viggen <oysteivi at trustix dot org> 2.9.4-4tr
- Rebuild

* Tue Feb 17 2004 Erlend Midttun <erlendbm at trustix dot org> 2.9.4-2tr
- Added missing "fi" to postinst.

* Thu Feb  5 2004 Oystein Viggen <oysteivi at trustix dot org> 2.9.4-1tr
- New upstream version (includes selinux support)
- Add patch from Russell Coker to have selinux support use the new API

* Mon Jun 23 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-20tr
- Removed ,755 from %defattr.

* Wed Jun 18 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-19tr
- Big rebuild

* Fri May  2 2003 Chr. H. Toldnes <christht at trustix dot org> 2.0.0-18ct
- Added PreReq: setup

* Fri May  2 2003 Chr. H. Toldnes <christht at trustix dot org> 2.0.0-17ct
- Added PreReq: tsl-utils, chkconfig

* Tue Apr 22 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-16em
- Fix uid/gid

* Wed Apr  9 2003 Gerald Dachs <gda at trustix dot org> 2.0.0-15gd
- Added PreReq on shadow-utils

* Mon Mar 24 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-14em
- Rebuilt against glibc 2.3.2.

* Fri Feb 28 2003 Chr. H. Toldnes <christht at trustix dot org> 2.0.0-13ct
- made /etc/fcrontab active before restart.
- PreReq: crontabs
- removed noreplace on config files.

* Thu Feb 23 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-12em
- Make setup quiet.

* Tue Feb 11 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-11em
- Fixed status in init script.
- Fixed user check.

* Thu Jan 16 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-10em
- Cleaned up init script.

* Thu Jan 16 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-9em
- symlink fcrontab to crontab.

* Thu Jan  9 2003 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-8em
- Use _initdir macro.
- Remove config(noreplace) on initscript.

* Thu Nov 21 2002 Chr. H. Toldnes <christht at trustix dot org> 2.0.0-7ct
- Now fcron initscript uses $INITLOCK

* Fri Nov  1 2002 Chr. H. Toldnes <christht at trustix dot org> 2.0.0-6ct
- Nice to have chkconfig in %post...

* Fri Oct 25 2002 Chr. H. Toldnes <christht at trustix dot org> 2.0.0-5ct
- added Requires crontabs

* Thu Oct  3 2002 Gerald Dachs <gda at trustix dot org> 2.0.0-4gd
- fixed stop of service fcron

* Wed Sep 11 2002 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-3em
- Added autostart.

* Tue Sep 10 2002 Erlend Midttun <erlendbm at trustix dot org> 2.0.0-2em
- Added Provifes: crond.

* Wed Jul 31 2002 Chr. H. Toldnes <christht at trustix dot org> 2.0.0-1ct
- Rewrite of spec for TSL 2.0
- Based on work by: 	Max Heijndijk <cchq@wanadoo.nl>
		        and Daouda Lo <daouda@mandrakesoft.com>
